import numpy as np
import torch
import torch.nn as nn

from toy_problem_mnist_analysis import analysis_classification
from toy_problem_mnist import mnist_fc

####################################################################################################
####################################################################################################
####################################################################################################

from linear import *

# model = nn.Sequential(*mnist_fc(layers,σ=nn.GELU(),linear_gen=lambda λ1,λ2: C_Linear_Binary_Sigmoid(λ1,λ2)))
# identifier = "C_Linear_Binary_Sigmoid(5)"
# analysis_classification(model,identifier,loss_fun=nn.MSELoss(),lr0=-2,lr1=-4,epochs=45,batch_size=256,fashion=True)

def debug(lin,name,layer_N = 5):
	layers = np.exp(np.linspace(np.log(28*28),np.log(10),layer_N))
	model = nn.Sequential(*mnist_fc(layers,σ=nn.GELU(),linear_gen=lambda λ1,λ2: lin(λ1,λ2)))
	identifier = f"{name}({layer_N})"
	analysis_classification(model,identifier,loss_fun=nn.MSELoss(),lr0=-2,lr1=-4,epochs=45,batch_size=256,fashion=True)

# debug(Linear_Funky,"Linear_Funky",layer_N = 5)
# debug(C_Linear,"C_Linear",layer_N = 5)
# debug(C_Linear_2_Softmax,"C_Linear_2_Softmax",layer_N = 5)
# debug(C_Linear_Binary_Sigmoid,"C_Linear_Binary",layer_N = 5)
# debug(C_Linear_Sigmoid,"C_Linear_Binary_Sigmoid",layer_N = 5)
# debug(C_Linear_Ternary,"C_Linear_Ternary",layer_N = 5)
# debug(C_Linear_Sigmoid_Ternary,"C_Linear_Ternary_Sigmoid",layer_N = 5)
